# -*- coding: utf-8 -*-
import wx, os, sys
import wx.html as html
import  wx.lib.newevent
import webbrowser

HW_SCROLLBAR_NEVER = wx.html.HW_SCROLLBAR_NEVER
ChatWindowEvent, EVT_CHAT_WINDOW_EVENT = wx.lib.newevent.NewEvent()
EVT_OBJECT_CLICK = 1
EVT_NICK_CLICK = 2
EVT_ANKETA_CLICK = 3

def CopyText(text):
    wx.TheClipboard.UsePrimarySelection(False)
    wx.TheClipboard.Open()
    wx.TheClipboard.SetData(wx.TextDataObject(text))
    wx.TheClipboard.Flush()
    wx.TheClipboard.Close()

class ChatWindowPopupMenu(wx.Menu):
    def __init__(self, parent, text, mode):
        wx.Menu.__init__(self)
        self.parent = parent
        self.mode = mode
        self.text = text
        if mode == 0:
            itemText = u"Скопировать"
        else:
            itemText = u"Скопировать адрес"
        mItem = wx.MenuItem(self, wx.NewId(), itemText)
        mItem.Enable(text!="")
        self.AppendItem(mItem)
        self.Bind(wx.EVT_MENU, self.OnItem, id=mItem.GetId())

    def OnItem(self, event):
        CopyText(self.text)

class ChatHtml(html.HtmlWindow):
    def __init__(self, *args, **kwargs):
        html.HtmlWindow.__init__(self, *args, **kwargs)

    def DoChatHtmlEvent(self, type, data):
        evt = ChatWindowEvent(type=type, data=data)
        self.GetEventHandler().ProcessEvent(evt)

    def OnCellClicked(self, cell, x, y, event):
        try:
            link = cell.GetLink(x, y)
        except:
            pass #хгень какая-то..-_-
        linkBtn = event.GetButton()
        selection = self.SelectionToText()
        if link is not None:
            params = link.GetHref().split('\x09')
            if (event.ShiftDown()) or (linkBtn==wx.MOUSE_BTN_MIDDLE):
                CopyText(params[0])
            elif selection!="" and linkBtn==wx.MOUSE_BTN_RIGHT:
                self.PopupMenu(ChatWindowPopupMenu(self,selection, 0), event.GetPosition())
            else:
                if(len(params)==2):
                    if(params[1]=='nic'):
                        if (linkBtn==wx.MOUSE_BTN_RIGHT):
                                self.DoChatHtmlEvent(EVT_NICK_CLICK, "private [%s]" % params[0])
                        else:
                            self.DoChatHtmlEvent(EVT_NICK_CLICK, "to [%s]" % params[0])
                    elif(params[1]=='private'):
                        self.DoChatHtmlEvent(EVT_NICK_CLICK, "private [%s]" % params[0])
                    elif(params[1]=='date'):
                        self.DoChatHtmlEvent(EVT_OBJECT_CLICK, ' {%s} ' % params[0])
                    elif(params[1]=='smile'):
                        self.DoChatHtmlEvent(EVT_OBJECT_CLICK, ' :%s: ' % params[0])
                    elif(params[1]=='advsmile'):
#                        if "win" in sys.platform:#TODO костыль
#                            try:
#                                params[0] = unicode(params[0].encode("cp1251"), "utf-8")
#                            except:
#                                pass
                        self.DoChatHtmlEvent(EVT_OBJECT_CLICK, ' :(%s): ' % params[0])
                    elif(params[1]=='anketa'):
                        self.DoChatHtmlEvent(EVT_ANKETA_CLICK, params[0])
                    elif(params[1]=='_blank' or params[1]=='_blahk'):
                        if (linkBtn==wx.MOUSE_BTN_RIGHT):
                            self.PopupMenu(ChatWindowPopupMenu(self,params[0], 1), event.GetPosition())
                        else:
                            webbrowser.open(params[0])
                else:
                    #print "Unsupported link: %s" % link.GetHref()
                    anchor = link.GetHref()[1:]
                    if self.HasAnchor(anchor):
                        self.ScrollToAnchor(anchor)
                    else:
                        print "Unsupported link: %s" % link.GetHref()
        else:
            if linkBtn==wx.MOUSE_BTN_RIGHT:
                self.PopupMenu(ChatWindowPopupMenu(self,selection, 0), event.GetPosition())
        event.Skip()

