# refreshthread.py
# -*- coding: utf-8 -*-

import wx, re, os
import common
from log import DoLog, debptint

import threading
from time import sleep, time

def GetTickCount():
    return int(time())

class RefreshThread(threading.Thread):
    def __init__(self,_notify_window):
        self._notify_window = _notify_window
        threading.Thread.__init__(self)
        self.event = threading.Event()
        self.SetNewIntervals()
        #self.SetOnlineUpdate()
        self.FLastChatUpdate=0
        self.FLastOnlineUpdate=0
        self.FSayList = []

    def __enter__(self):
        self.start()

    def __exit__(self, ex_type, ex_value, ex_traceback):
        self.event.set()
        self.join()

    def ForceChatRefresh(self):
         self.FLastChatUpdate=0

    def ForceOnlineRefresh(self):
        self.FLastOnlineUpdate=0

    def SetNewIntervals(self):
        self.FOnlineUpdateInterval = common.OnlineUpdateInterval
        self.FChatUpdateInterval = common.ChatUpdateInterval


    def SayText(self, text):
        if (text==''):
            self.ForceChatRefresh()
            self.ForceOnlineRefresh()
        else:
            self.FSayList.append(text+u'\xA0')
            #self.FSayList.append(text)
    def msgsendError(self, msg):
        evt = common.ChatNotifyEvent(type=common.NOTIFY_MSG_ENCODING_ERROR,attr1=msg)
        wx.PostEvent(self._notify_window, evt)

    def parseImages(self, msg):
        replase = '<glink href="\\2" target="smile"><img src="pixmaps/smileys/\\2.gif"></glink>'
        msg = re.sub('(?i)(<IMG SRC=/i/smile/(.+?)\.gif WIDTH=\d\d HEIGHT=\d\d BORDER=\d>)', replase, msg, 0)
        return msg

    def parseMsg(self, msg):
        #msgFrom = re.search('\"\+\'>(.+?)</a>\]',msg).group(1)
        msgFrom = re.search('JavaScript:top.AddTo\("(.+?)"\)',msg).group(1)
        msgDate = re.search('<font class=date(|2)>(\d\d:\d\d)</font>',msg).group(2)

        if (msgFrom in common.BanList):
            return ''

        if(re.search('\xA0',msg)):
            dateColor = "#03cbc4"
        else:
            dateColor = "#b8b8b8"

        if not('<font color=' in msg):
            msg = re.sub('</a>] ','</a>] <font color=#000000>',msg)+'</font>'

        if(u'</font> Вас' in msg):
            msgType = common.MSG_TYPE_ARRIVE
            msgDateStr = '<glink href="%s" target="date" colour="#b8b8b8"><font size=-1>%s</font></glink> '%(msgDate, msgDate)
            common.TryPlaySound(msgType)
            return u'%sВас приветствует:  [<glink href="%s" target="nic">%s</glink>]<br>' % (msgDateStr, msgFrom, msgFrom)

        if(u'</a>] <font color=#000000>ушел.' in msg):
            msgType = common.MSG_TYPE_LEAVE
            msgDateStr = '<glink href="%s" target="date"><font color="#b8b8b8" size=-1>%s</font></glink> '%(msgDate, msgDate)
            common.TryPlaySound(msgType)
            return u'%sВас покидает:  [<glink href="%s" target="nic">%s</glink>]<br>' % (msgDateStr, msgFrom, msgFrom)

        if not re.search("</font>\s*?<BR>",msg):
                """парсер табы в тексте не понимает (скрипт чата обрезает по табу и теги не закрывает)################"""
                debptint('TAB detected: %s' % msg, 4)
                msg = re.sub('<BR>','</font> <BR>',msg)

        if(('<b>' in msg) and ('date2>' in msg)):
            msgType = common.MSG_TYPE_PERSONAL
            msgDateStr = '<glink href="%s" target="date" colour="#007000"><font size=-1>%s</font></glink> '%(msgDate, msgDate)
            #msgMsg = re.search('<font color=.{7}>.+?</font>',msg).group(0)
            msgMsg = re.search('<font color=.+?>.+?</font>',msg).group(0)
            msgMsg = self.parseImages(msgMsg)
            result = '%s[<glink href="%s" target="nic">%s</glink>] %s' % (msgDateStr, msgFrom, msgFrom, msgMsg)
            evt = common.ChatNotifyEvent(type=msgType)
            wx.PostEvent(self._notify_window, evt)

        elif(('private>' in msg) and ('date2>' in msg)):#входящий приват
            msgType = common.MSG_TYPE_PRIVATE
            msgDateStr = '<glink href="%s" target="date"><font color=red size=-1>%s</font></glink> '%(msgDate, msgDate)
            msgTo = re.search('<font class=private>private \[(.+?)\]</font>',msg).group(1)
            #msgColor = re.search('<font color=(.{7})>',msg).group(1)
            msgColor = re.search('<font color=(.+?)>',msg).group(1)
            msgMsg =self.parseImages(re.search('</a> (.+?)</font>',msg).group(1))
            result = '%s[<glink href="%s" target="nic">%s</glink>] <glink href="%s" target="private">\
                <font color=red bgcolor="#FBAEAE"><b>private [%s]</b></font></glink> <font color="%s">%s</font>' \
                % (msgDateStr, msgFrom, msgFrom, msgFrom, msgTo, msgColor, msgMsg)
            evt = common.ChatNotifyEvent(type=msgType)
            wx.PostEvent(self._notify_window, evt)

        elif (('private>' in msg) and ('date>' in msg)):#исходящий приват
            msgType = common.MSG_TYPE_OTHER
            msgDateStr = '<glink href="%s" target="date"><font color="%s" size=-1>%s</font></glink> '%(msgDate, dateColor, msgDate)
            msgTo = re.search('<font class=private>private \[(.+?)\]</font>',msg).group(1)
            #msgColor = re.search('<font color=(.{7})>',msg).group(1)
            msgColor = re.search('<font color=(.+?)>',msg).group(1)
            msgMsg =self.parseImages(re.search('</a> (.+?)</font>',msg).group(1))
            result = '%s[<glink href="%s" target="nic">%s</glink>] <glink href="%s" target="private">\
                <font color=red bgcolor="#FBAEAE"><b>private [%s]</b></font></glink> <font color="%s">%s</font>'\
                % (msgDateStr, msgFrom, msgFrom, msgTo, msgTo, msgColor, msgMsg)
        else:
            msgType = common.MSG_TYPE_OTHER
            msgDateStr = '<glink href="%s" target="date"><font color="%s" size=-1>%s</font></glink> '%(msgDate, dateColor, msgDate)
            #msgMsg = __parseImages(re.search('<font color=.{7}>.+?</font>',msg).group(0))

            msgMsg = self.parseImages(re.search('<font color=.+?>.+?</font>',msg).group(0))
            result = '%s[<glink href="%s" target="nic">%s</glink>] %s' % (msgDateStr, msgFrom, msgFrom, msgMsg)

        common.TryPlaySound(msgType)

        debptint('msgType: %s' % msgType, 4)
        debptint('__parseMsg: %s' % result, 4)

        return result+"<br>"

    def ParseText(self,text):
        retval = ''
        if (text == ''):
            return retval
        text = unicode(text, 'cp1251')
        try:
            common.ChatLSize = re.search("\.document\.F1\.lastsize\.value='(.+?)'",text).group(1)
            common.ChatLId = re.search("\.document\.F1\.lastid\.value='(.+?)'",text).group(1)
        except:
            DoLog('__ParseText: Can`t find ChatLSize and ChatLId')
            return retval
        #msgset = re.findall("innerHTML \+= '(<!--.*?<BR>)';",text)
        msgset = re.findall("(<!--.*?<BR>)';",text)

        for msg in msgset:
            try:
                retval+=self.parseMsg(msg)
                debptint('__incomingMsg: %s' % msg, 3)
            except Exception, ex:
                DoLog('Can`t parse message: %s' % msg)
                DoLog('Exception: %s [%s]' % (ex.message, ex.args))
                continue
        common.SndFlag = True
        return retval

    def LoadAndParseText(self, MsgToSend):
        if (common.UserName == '') or (common.ChatId == ''):
            return ''

        #Заглушка
        if(common.debugui):
            f = open('debugui/chat2[1]5.pl')
            s = f.read()
            f.close()
            return self.ParseText(s)
        #Заглушка

        #MsgToSend = re.sub(os.linesep,' ',MsgToSend.strip(),0) #Откусим пробелы и переносы строк
        MsgToSend = re.sub('\n',' ',MsgToSend.strip(),0)
        MsgToSend = re.sub('\r','',MsgToSend,0)# а вдруг?
        MsgToSend = re.sub('\t',' ',MsgToSend,0)
        if (MsgToSend != ''):
            MsgToSend = MsgToSend[:220]
            params = {"lastsize":common.ChatLSize,"lastid":common.ChatLId,"color":common.ChatColor[1:],"text":MsgToSend}
        else:
            params = {"lastsize":common.ChatLSize,"lastid":common.ChatLId,"color":common.ChatColor[1:]}
        cookiestr = "chat=%s; chatid=%s" % (common.UserName, common.ChatId)
        response = common.GetPage("GET", common.ChatURL, cookiestr, params,common.ProxyAddr,common.ProxyPass,common.version)

        if (response['status'] != 200):
            common.SendStatus(self._notify_window,"[%d] Server Error."%response['status'])
            if (MsgToSend != ''):
                evt = common.ChatNotifyEvent(type=common.NOTIFY_MSG_SEND_ERROR,attr1=MsgToSend)
                wx.PostEvent(self._notify_window, evt)
            return ''
        return self.ParseText(response['content'])

    def run(self): #Поехали!
        while not(self.event.isSet()):
            if (len(self.FSayList) != 0):
                #выгребли первую фразу (настоящему ковбою всегда есть, что сказать)
                ToSay = self.FSayList.pop(0)
                #print ToSay
                try:
                    ToSay = ToSay.encode('cp1251')
                except:
                    self.msgsendError(ToSay)
                    ToSay = ''
            else:
                ToSay = ''

            if GetTickCount() - self.FLastOnlineUpdate >= self.FOnlineUpdateInterval:
                common.SendStatus(self._notify_window, u'загрузка онлайн-списка')
                #print u'загрузка онлайн-списка'
                msgs = common.LoadAndParseOnlineList(self._notify_window)
                if (msgs != ''):
                    evt = common.ChatNotifyEvent(type=common.NOTIFY_ONLINE_OK,attr1=msgs)
                    wx.PostEvent(self._notify_window, evt)
                common.SendStatus(self._notify_window, 'online [OK]')
                self.FLastOnlineUpdate=GetTickCount()

            if (GetTickCount() - self.FLastChatUpdate >= self.FChatUpdateInterval) or (ToSay != ''):
                common.SendStatus(self._notify_window, u'загрузка сообщений')
                #print u'загрузка сообщений'
                msgs = self.LoadAndParseText(ToSay)
                if (msgs != ''):
                    evt = common.ChatNotifyEvent(type=common.NOTIFY_CHAT_OK,attr1=msgs)
                    wx.PostEvent(self._notify_window, evt)
                common.SendStatus(self._notify_window, 'chat [OK]')
                self.FLastChatUpdate=GetTickCount()


            sleep(0.5)

    #Приехали..
#        common.Logout()
#        evt = common.ChatNotifyEvent(type=common.NOTIFY_TAKTHREADDIES)
#        wx.PostEvent(self._notify_window, evt)
