# updateu.py
# -*- coding: utf-8 -*-
import wx
from threading import Thread
import urllib, sys, os, urllib2
import tarfile
from common import ChatNotifyEvent

rem_file = 'http://k210.org/get/523'
loc_file = 'coreupdate.tar.gz'
NOTIFY_DOWNLOAD_START = 101
NOTIFY_DOWNLOAD_PROGRESS = 102
NOTIFY_DOWNLOAD_END = 103

class ProxyPasswordMgr:
    def __init__(self):
        self.user = self.passwd = None
    def add_password(self, realm, uri, user, passwd):
        self.user = user
        self.passwd = passwd
    def find_user_password(self, realm, authuri):
        return self.user, self.passwd

class Abort(Exception):
    pass

class ChatUpdater(Thread):
    def __init__(self, _notify_window, localdir, ProxyAddr='', ProxyPass=''):
        Thread.__init__(self)
        self._notify_window = _notify_window
        self.stop = False
        self.ProxyAddr = ProxyAddr
        self.ProxyPass = ProxyPass
        self.localfile = os.path.join(localdir,loc_file)

    def __dlProgress(self, count, blockSize, totalSize):
        percent = int(count*blockSize*100/totalSize)
        if percent<0: percent=0
        if percent>100: percent=100
        evt = ChatNotifyEvent(type=NOTIFY_DOWNLOAD_PROGRESS, rem_file=rem_file, percent=percent)
        wx.PostEvent(self._notify_window, evt)

    def __PostErrorEvent(self):
        emsg = u"\nDownloadError: Не могу загрузить %s" % rem_file
        evt = ChatNotifyEvent(type=NOTIFY_DOWNLOAD_END, error=True, emsg = emsg)
        wx.PostEvent(self._notify_window, evt)

    def __DownloadFileWithProxy(self):
        proxy = urllib2.ProxyHandler({"http" : self.ProxyAddr})
        if self.ProxyPass!="":
            user, password =self.ProxyPass.split(":")
            proxy_auth_handler = urllib2.ProxyBasicAuthHandler(ProxyPasswordMgr())
            proxy_auth_handler.add_password(None, None, user, password)
            opener = urllib2.build_opener(proxy, proxy_auth_handler)
        else:
            opener = urllib2.build_opener(proxy)

        urllib2.install_opener(opener)
        try:
            response =urllib2.urlopen(rem_file)
        except:
            self.__PostErrorEvent()
            return False

        f = file(self.localfile, 'wb')
        try:
            f.write(response.read())
        except:
            f.close()
            self.__PostErrorEvent()
            return False
        return True

    def run(self):
        try:
            evt = ChatNotifyEvent(type=NOTIFY_DOWNLOAD_START)
            wx.PostEvent(self._notify_window, evt)

            if self.ProxyAddr!="":
                self.__DownloadFileWithProxy()
            else:
                urllib.urlretrieve(rem_file, self.localfile, reporthook=self.__dlProgress)
            tar = tarfile.open(self.localfile)
            tar.extractall()
            tar.close()
            os.remove(self.localfile)

            evt = ChatNotifyEvent(type=NOTIFY_DOWNLOAD_END, error=False)
            wx.PostEvent(self._notify_window, evt)

        except Abort, KeyBoardInterrupt:
            print 'Aborted'
        except:
            self.stop = True
            self.__PostErrorEvent()

    def abort(self):
        self.stop = True
