# -*- coding: utf-8 -*-
#turbouser.py

import wx
import base

class Render(wx.EvtHandler):
    def __init__(self):
        wx.EvtHandler.__init__(self)
        self.frames = 0
        self.maxfps = 0
        self.start = wx.GetLocalTime()-1
        self.Bind(wx.EVT_ENTER_WINDOW, self.__OnEnter)
        self.Bind(wx.EVT_LEAVE_WINDOW, self.__OnLeave)
        self.Bind(wx.EVT_PAINT, self.__OnPaint)

    def __OnEnter(self, event):
        self.maxfps = 100
        event.Skip()

    def __OnLeave(self, event):
        self.maxfps = 0
        event.Skip()

    def __OnPaint(self, event):
        wnd = event.GetEventObject()
        x,y,width,height = wnd.GetUpdateRegion().GetBox()
        time = wx.GetLocalTime()-self.start
        fps = self.frames/time

        if fps<=self.maxfps or x==0:
            self.frames+=1
            event.Skip()

class StaticS(base.Baselugin):
    def __init__(self,parent,modulename,active):
        base.Baselugin.__init__(self,parent,modulename,active)

        self.name = u"Заморозка смайлов"
        self.version = "version 1.0"
        self.description =u"""Снижает нагрузку на процессор."""
        self.wnds = [parent.htmlMain,parent.htmlSmileys]
        self.renders = []
        for wnd in self.wnds:
            self.renders.append(Render())
        self.SetActive(active)

    def SetActive(self,active = True):
        self.active = active
        i=0
        for wnd in self.wnds:
            wnd.SetDoubleBuffered(not self.active)
            if self.active:
                wnd.PushEventHandler(self.renders[i])
            else:
                try:
                    wx.EvtHandler.ProcessPendingEvents
                    wnd.RemoveEventHandler(self.renders[i])
                except:
                    pass
            i+=1



